#include <stdio.h>

/*

	# Automatic Installer For bash-3.0-geinpeek

*/

/* ProtoType */
int download_file(char *src_url);
int checking_file(char *bin_file);
int xtract_package(char *src_file);
void select_and_patch();
void compile_geinpeek_bash();
void make_install();
void make_clean();


char needed[][]=
{
	"/bin/bash",
     	"/usr/bin/patch",
     	NULL,
};

char download_list[][]=
{
	"http://ftp.gnu.org/pub/gnu/bash/bash-3.0.tar.gz",
     	"http://kldp.net/frs/download.php/3191/bash-3.0-geinpeek-0.2.tar.gz",
     	NULL,
};

char cong[]=
{
	"Welcome to BASH-GEINPEEK's world :)\n"
	"Try it now : # ghelper 90.txt\n"
};
	

int main()
{

	unsigned int ind = 0, ret = 0;

	/* step 1 : check public web's GNU bash(tar.gz) and geinpeek is available & download src file */

	for(i = 0; download_list[i++] != NULL;){
		if(download_file(download_list[i]) != 0){
			ret ++;
			fprintf(stderr, "source code(tar.gz) not found on internet:\n\t=> %s\n", download_list[i]);
		}
	}

	if(ret != 0)
		return(1);

	ret = 0;

	/* step 2 : utility checking ( like as /bin/bash and /usr/bin/patch */
	
	for(i = 0; needed[i++] != NULL;){
		if(checking_file(needed[i]) != 0){
			ret ++;
			fprintf(stderr, "needed utility : %s\n", needed[i]);
		}
	}
	
	if(ret != 0)
		return(2);


	/* step 3 : cd /root/blackhole; tar xzvf *.tar.gz */

	for(i = 0; download_list[i++] != NULL;){
		if(xtract_package(download_list[i]) != 0){
			ret ++;
			fprintf(stderr, "downloaded files(tar.gz) extraction failed :\n\t=> %s\n" download_list[i]);
		}
	}

	if(ret != 0)
		return(3);

	ret = 0;

	
	/* step 4 : apply geinpeek into original bash source using /usr/bin/patch tool */
	
	select_and_patch();	
		
	/* step 5 : compile */
	
	compile_geinpeek_bash();

	/* step 6 : backup original bash binary(/bin/bash) & copy patched bash into as /bin/bash & geinpeek utilities */
	
	make_install();

	/* step 7 : Out Help and Install Complete Message */
	
	fprintf(stdout, "%s\n", cong);



}
